#include"dottle.hpp"




namespace{


TextBox*
filename_txtbox;


void
save(Button&  btn)
{
    if(btn->test_unpressed())
    {
      auto  s = filename_txtbox->get();

        if(s.size())
        {
          const char*  ext = ".dottle";

            if(s.rfind(ext) == std::string::npos)
            {
              s += ext;
            }


          ::save(s.data());
        }
    }
}


void
save_as_png(Button&  btn)
{
    if(btn->test_unpressed())
    {
      auto  s = filename_txtbox->get();

        if(s.size())
        {
          const char*  ext = ".png";

            if(s.rfind(ext) == std::string::npos)
            {
              s += ext;
            }


          paper.save_as_png(s.data(),0,nullptr);
        }
    }
}


}




Widget*
create_io_widget()
{
  auto  nd = new TableColumn;

  auto  l_btn = new RotorButton(u"save");
  auto  r_btn = new RotorButton(u"sava as PNG");


  filename_txtbox = new TextBox("",32);

  l_btn->set_callback(save);
  r_btn->set_callback(save_as_png);

  nd->insert(filename_txtbox);
  nd->insert(l_btn);
  nd->insert(r_btn);

  return nd;
}


void
set_filename(const std::string  s)
{
  filename_txtbox->set(s);
}




