#ifndef OAT_IRECO_HPP
#define OAT_IRECO_HPP


#include"util.hpp"




namespace oat{


struct
Ireco
{
public:
  std::string   name;
  std::string  value;

  std::vector<Ireco*>  children;


  ~Ireco();


  const Ireco&  operator[](int  i) const;

  bool  find(const char*  path, const Ireco*&  ireco) const;

  bool  find(std::initializer_list<const char*>  path, int&  i) const;
  bool  find(std::initializer_list<const char*>  path, const char*&  s) const;
  bool  find(std::initializer_list<const char*>  path, const Ireco*&  ireco) const;
  bool  find(std::initializer_list<const char*>  path, const char*  name, std::vector<const Ireco*>&  ireco_buf) const;

};


Ireco*  load_ireco(const char*  path);


}


#endif




