#include"block_sheet.hpp"




void
BlockSheet::
touch(Area&  area, const SDL_Point&  pt, const SheetPiece*  piece)
{
  SheetPiece*  last_touched_piece = nullptr;

    if(touched_piece)
    {
      last_touched_piece = touched_piece;
    }


  Sheet::touch(area,pt,nullptr);

    if(touched_piece)
    {
        if(last_touched_piece)
        {
            for(auto&  side: last_touched_piece->sides)
            {
              side.color = get_default_color(15);
            }
        }


        for(auto&  side: touched_piece->sides)
        {
          side.color = 0xFFFFFFFF;
        }


      area.request_redraw();
    }
}




