#ifndef _ISOMT_CANVAS_HPP_
#define _ISOMT_CANVAS_HPP_


#include"piece.hpp"
#include"sheet.hpp"


enum{
  pixel_size = 8,
};


struct
Canvas
{
  Color*  table[side_length][side_length];

  uint8_t  mark_table[side_length][side_length];

  Piece*  piece=nullptr;


  void  reset(Piece*  _piece);

  void  fill_next(int  x, int  y, Color  target_color, Color  new_color);
  void       fill(int  x, int  y, Color  color);

  void  draw(Area&  area);
  void  touch(Area&  area, const SDL_Point&  pt, Color  color, bool  filling=false);

};




#endif




