#include"painter_private.hpp"
#include"palette8.hpp"




namespace painter{


Paper*                     drawing_paper;
std::vector<const Paper*>  showing_papers;

Paper::Palette*  palette = &palette8;

Paper  copy_paper;

Paper::Frame  frame;

std::vector<Widget*>  relative_widgets;

int  whole_pixel_size;
int   part_pixel_size;

SDL_Point  whole_size;
SDL_Rect    part_rect;

int  x_offset;
int  y_offset;

int  using_frame;
int  using_grid;

Paper::DotString  string_buffer;
Paper::DotString  stroke_buffer;

bool  base_mover_using;

int  state;




void
update()
{
    if(widgets.drawing_area)
    {
      widgets.drawing_area->request_redraw();
    }


    if(widgets.part_drawing_area)
    {
      widgets.part_drawing_area->request_redraw();
    }


    for(auto  ptr: relative_widgets)
    {
      ptr->request_redraw();
    }
}


}




