#include"painter_private.hpp"




namespace painter{




void
draw(Area&  area)
{
  area.fill(palette->get_color(0));


    for(auto  pp: showing_papers)
    {
      pp->draw_part(area,x_base+margine,
                         y_base+margine,whole_size.x,
                                        whole_size.y,whole_pixel_size,*palette);
    }


    if(using_grid)
    {
      draw_grid(area,whole_size.x,whole_size.y,whole_pixel_size);
    }


    if(using_frame)
    {
      auto  frame_rect = make_rect(*frame);

      int  x = frame_rect.x*pixel_size-(x_base*pixel_size);
      int  y = frame_rect.y*pixel_size-(y_base*pixel_size);
      int  w = frame_rect.w*pixel_size;
      int  h = frame_rect.h*pixel_size;

      area.draw_rect_safety(x,y,w,h,white_color,true);
    }


  int  x = (pixel_size*x_offset);
  int  y = (pixel_size*y_offset);

    if(pixel_size == 1)
    {
      area.draw_rect(x ,y  ,2,2,black_color);
      area.draw_dot(x+1,y+1,    white_color);
    }

  else
    if(pixel_size == 2)
    {
      area.draw_rect(x  ,y  ,3,3,black_color);
      area.draw_rect(x+1,y+1,1,1,white_color);
    }

  else
    {
      area.draw_rect(x  ,y  ,pixel_size  ,pixel_size  ,black_color);
      area.draw_rect(x+1,y+1,pixel_size-2,pixel_size-2,white_color);
    }
}




}




