#ifndef _PAPER_DOT_
#define _PAPER_DOT_


#include"paper.hpp"




struct
Paper::
Dot
{
  uint32_t  code;

  void  get(int&  x, int&  y, int&  pixel_data) const
  {
    x          = ((code>>20)&0xFFF);
    y          = ((code>> 8)&0xFFF);
    pixel_data = ((code    )&0x0FF);
  }


  constexpr Dot(uint32_t  _code): code(_code){}
  constexpr Dot(int  x, int  y, uint8_t  data): code((x<<20)|(y<<8)|data){}

};


#endif




