#ifndef OAT_ROOT_HPP
#define OAT_ROOT_HPP


#include"util.hpp"


namespace oat{


class Node;
class Widget;


namespace sys{


extern uint8_t*  main_pixels;
extern int        main_pitch;


using DropCallback = void  (*)(const std::string&  path);


void  make_window(const char*  _title, int  x, int  y, Node*  _root, DropCallback  _drop_cb=nullptr);
void  clean_window();

void  set_keyreceive_widget(Widget*  wid);

void  save_png(const char*  path);

void  draw();

void  update();

bool  process_event();

}}




#endif




