#ifndef OAT_NODE_HPP
#define OAT_NODE_HPP


#include"widget.hpp"
#include<memory>
#include<list>


namespace oat{




class  Root;


class
Node: public  Widget
{
protected:
  std::list<Widget*>  children;

public:
   Node();
  ~Node();


  void  set_userdata(void*  ptr, bool  spread=false);

  void  cleanup(int  x, int  y);

  void  insert(Widget*  wid, int  x=0, int  y=0);

  Widget*  test(const Mouse&  mouse);

  void    draw();
  void  redraw();

};


}




#endif




