#include"table.hpp"
#include"util.hpp"




namespace oat{




TableElement::
TableElement(int  margine, std::initializer_list<Widget*>  ls)
{
  set_margine(margine);

    for(auto  ptr: ls)
    {
      insert(ptr);
    }
}




void
TableElement::
set_margine(int  v)
{
  table_margine = v;

  set_flag(WID_ST_dirty_flag,true);
}




void
TableColumn::
cleanup(int  x, int  y)
{
  widget_parameter.top  = (y+widget_parameter.rel_point.y);
  widget_parameter.left = (x+widget_parameter.rel_point.x);

  widget_parameter.bottom = widget_parameter.top;

    for(auto&  it: children)
    {
        if(it->test_flag(WID_ST_dirty_flag))
        {
          it->cleanup(widget_parameter.left,widget_parameter.bottom);

          widget_parameter.right = std::max(widget_parameter.right,it->get_parameter().right);

          widget_parameter.bottom += (it->get_parameter().height+table_margine);
        }
    }


  widget_parameter.width  = (widget_parameter.right -widget_parameter.left);
  widget_parameter.height = (widget_parameter.bottom-widget_parameter.top );

  reset_flag(WID_ST_dirty_flag);
}


void
TableRow::
cleanup(int  x, int  y)
{
  widget_parameter.top  = (y+widget_parameter.rel_point.y);
  widget_parameter.left = (x+widget_parameter.rel_point.x);

  widget_parameter.right = widget_parameter.left;

    for(auto&  it: children)
    {
        if(it->test_flag(WID_ST_dirty_flag))
        {
          it->cleanup(widget_parameter.right,widget_parameter.top);

          widget_parameter.right += (it->get_parameter().width+table_margine);

          widget_parameter.bottom = std::max(widget_parameter.bottom,it->get_parameter().bottom);
        }
    }


  widget_parameter.width  = (widget_parameter.right -widget_parameter.left);
  widget_parameter.height = (widget_parameter.bottom-widget_parameter.top );

  reset_flag(WID_ST_dirty_flag);
}


}




