#include"widget_parameter.hpp"




namespace oat{




WidgetParameter::
WidgetParameter()
{
  std::memset(this,0,sizeof(*this));
}


WidgetParameter::
operator SDL_Rect() const
{
  return SDL_Rect{left,top,width,height};
}


void
WidgetParameter::
update(int  x, int  y)
{
  top  = (y+rel_point.y);
  left = (x+rel_point.x);

  margined_top  = (top +top_margin );
  margined_left = (left+left_margin);

  unmargined_right  = (margined_left+width );
  unmargined_bottom = (margined_top +height);

  right  = (unmargined_right +right_margin );
  bottom = (unmargined_bottom+bottom_margin);
}


void
WidgetParameter::
print() const
{
  printf("     w:%4d\n",width);
  printf("     h:%4d\n",height);
  printf("   top:%4d\n",top);
  printf("  left:%4d\n",left);
  printf(" right:%4d\n",right);
  printf("bottom:%4d\n\n",bottom);
};


}




