#ifndef OAT_FONT_HPP
#define OAT_FONT_HPP


#include<cstdint>
#include<string>


namespace  oat{
namespace font{


enum{
  w = 12,
  h = 12,

  small_w = w/2,

};




size_t  get_width(const std::u16string&  s);


int  draw_ascii(  char      c, uint8_t*  pixels, int  pitch, int  x, int  y, uint32_t  color);
int  draw_unicode(char16_t  c, uint8_t*  pixels, int  pitch, int  x, int  y, uint32_t  color);

void  draw_ascii(  const char*      s, uint8_t*  pixels, int  pitch, int  x, int  y, uint32_t  color);
void  draw_unicode(const char16_t*  s, uint8_t*  pixels, int  pitch, int  x, int  y, uint32_t  color);


namespace unicode
{
  const uint16_t*  get_data(int  c);
}


namespace ascii
{
  const uint8_t*  get_data(int  c);
}


}}




#endif




