#include"tilist.hpp"
#include"../pngbuffer.hpp"




RMap::
RMap()
{
  x_pos = 0;
  y_pos = 0;
  z_pos = 0;

    rep(z,depth){
    rep(y, size){
    rep(x, size){
      tiles[z][y][x] = &map.get_tile(0,0);
    }}}
}




const Tile&  RMap::get_tile(int  x, int  y, int  z                   ) const{return *tiles[z][y][x];}
void         RMap::set_tile(int  x, int  y, int  z, const Tile&  tile)      {tiles[z][y][x] = &tile;}


int  RMap::get_x_pos() const{return x_pos;}
int  RMap::get_y_pos() const{return y_pos;}
int  RMap::get_z_pos() const{return z_pos;}

void  RMap::set_x_pos(int  x){x_pos = x;}
void  RMap::set_y_pos(int  y){y_pos = y;}
void  RMap::set_z_pos(int  z){z_pos = z;}


void
RMap::
save_as_png(const char*  path) const
{
  PNGBuffer  buf;

  buf.make_indexed_color(Tile::size*RMap::size,
                         Tile::size*RMap::size,Palette8::w*Palette8::h,palette8.get_pointer());


    rep(y,size){
    rep(x,size){
      auto&  src = get_tile(x,y,0);

        rep(yy,Tile::size){
        rep(xx,Tile::size){
          *buf.get_index((Tile::size*x)+xx,
                         (Tile::size*y)+yy) = src.get_pixel(xx,yy);

        }}
    }}


    rep(z,depth-1){
    rep(y,size){
    rep(x,size){
      auto&  src = get_tile(x,y,z+1);

        rep(yy,Tile::size){
        rep(xx,Tile::size){
          auto  pix = src.get_pixel(xx,yy);

            if(pix)
            {
              *buf.get_index((Tile::size*x)+xx,
                             (Tile::size*y)+yy) = pix;

            }
        }}
    }}}


  buf.save(path);
}




