#ifndef RMAP_HPP
#define RMAP_HPP


#include"tile.hpp"


class
RMap
{
public:
  enum{
     size=10,
    depth=4,
  };

private:
  const Tile*  tiles[depth][size][size];

  int  x_pos;
  int  y_pos;
  int  z_pos;

public:
  RMap();

  const Tile&  get_tile(int  x, int  y, int  z                   ) const;
  void         set_tile(int  x, int  y, int  z, const Tile&  tile)      ;

  int  get_x_pos() const;
  int  get_y_pos() const;
  int  get_z_pos() const;

  void  set_x_pos(int  x);
  void  set_y_pos(int  y);
  void  set_z_pos(int  z);

  void  save_as_png(const char*  path) const;

  struct Widgets{
    Area*  area;

    RadioBox*  radbox;
    CheckBox*  chkbox;

    void  initialize();
  } widgets;

};




#endif




