#include"tilist.hpp"




Map    map;
RMap  rmap;



namespace{


Widget*
tilemake_widget;


Widget*
mapmake_widget;


Widget*
create_tilemake_widget()
{
  Node*  view = new TableColumn;

  view->insert(painter::widgets.brush_label );
  view->insert(painter::widgets.drawing_area);


  Node*  pal = new TableRow;

  pal->insert(palette8.widgets.area     );
  pal->insert(colorchooser.widgets.node);


  Node*  tools = new TableColumn;

  tools->insert(painter::widgets.radiobox);
  tools->insert(painter::widgets.revolve_widget);
  tools->insert(painter::widgets.reverse_widget);
  tools->insert(painter::widgets.mirror_widget);
  tools->insert(painter::widgets.shift_ud_widget);
  tools->insert(painter::widgets.shift_lr_widget);


  Node*  buttons = new TableColumn;

  buttons->insert(painter::widgets.undo_button);
  buttons->insert(painter::widgets.copy_button);
  buttons->insert(painter::widgets.grid_button);


  Node*  nd = new TableRow;

  nd->insert(view);
  nd->insert(tools);
  nd->insert(buttons);
  nd->insert(pal);

  tilemake_widget = nd;

  return nd;
}


void
update()
{
   map.widgets.area->request_redraw();
  rmap.widgets.area->request_redraw();
}


}


Widget*
create_united_widget()
{
  Node*  nd = new Node;

  painter::colorchooser.widgets.initialize();
  painter::palette8.widgets.initialize();
  map.widgets.initialize();
  rmap.widgets.initialize();

    rep(i,6)
    {
      int  l = (i? ((i<<5)|0b11111):0);

      palette8.set_color(i,l,l,l);
    }


  painter::reset_whole(Tile::size,Tile::size,8);

  painter::reset_drawing(map.get_tile(0,0));
  painter::push_showing(map.get_tile(0,0));

  painter::set_relative_widgets({map.widgets.area});

  painter::widgets.initialize();


  auto  right_nd = new Node;

  right_nd->insert(map.widgets.area,0,0);


  right_nd->insert(new TableColumn(8,{map.widgets.ud_shift_widget,
                                      map.widgets.lr_shift_widget,
                                      map.widgets.copy_button,
                                      map.widgets.paste_button,
                                      map.widgets.tppaste_button,
                                      }),320);

  right_nd->insert(new TableColumn(8,{rmap.widgets.radbox,rmap.widgets.chkbox}),340,160);


  right_nd->insert( map.widgets.saving_node   ,480,540);



  right_nd->insert(create_tilemake_widget(),0,340);

  nd->insert(right_nd,0,0);

  nd->insert(new TableColumn(8,{rmap.widgets.area}),460,0);

  return nd;
}


void
update_draw()
{
  painter::widgets.drawing_area->request_redraw();

  map.widgets.area->request_redraw();
  rmap.widgets.area->request_redraw();
}




