#ifndef OAT_LABEL_HPP
#define OAT_LABEL_HPP


#include"widget.hpp"


namespace oat{


class
Label: public Widget
{
protected:
  std::u16string  text;

public:
  Label(const std::u16string&  s, int  maxlen=0);

  void                   set(const std::u16string&  s)      ;
  const std::u16string&  get(                        ) const;

  void  push(char16_t  c);

  void  printf(const char*  fmt, ...);

  void  draw();


};




}




#endif




