#ifndef OAT_TABLE_HPP
#define OAT_TABLE_HPP


#include"node.hpp"
#include<initializer_list>


namespace oat{


class
TableElement: public Node
{
protected:
  enum{default_margine=8};

  int  table_margine;

public:
  TableElement(int  margine, std::initializer_list<Widget*>  ls);

  void  set_margine(int  v);

};


class
TableRow: public TableElement
{
public:
  TableRow(int  margine=default_margine, std::initializer_list<Widget*>  ls={}): TableElement(margine,ls){}

  void  cleanup(int  x, int  y);

};


class
TableColumn: public TableElement
{
public:
  TableColumn(int  margine=default_margine, std::initializer_list<Widget*>  ls={}): TableElement(margine,ls){}

  void  cleanup(int  x, int  y);

};




}




#endif




