#ifndef OAT_TEXTBOX_HPP
#define OAT_TEXTBOX_HPP


#include"widget.hpp"


namespace oat{


class
TextBox: public Widget
{
private:
  std::string  text;

  int  pos;

  const int  length_max;

public:
  TextBox(const char*  s, int  max=0);

  const std::string&  get() const;
  void  set(const std::string&  s);

  void  draw();

  void  process(const SDL_KeyboardEvent&  evt);

};




}




#endif




