#ifndef OAT_WIDGET_PARAMETER_HPP
#define OAT_WIDGET_PARAMETER_HPP


#include"../util.hpp"


namespace oat{



struct
WidgetParameter
{
  Point  rel_point;

  uint16_t   width;
  uint16_t  height;

  uint16_t     top;
  uint16_t    left;
  uint16_t   right;
  uint16_t  bottom;

  uint16_t     top_margin;
  uint16_t    left_margin;
  uint16_t   right_margin;
  uint16_t  bottom_margin;

  uint16_t  margined_top;
  uint16_t  margined_left;

  uint16_t  unmargined_bottom;
  uint16_t  unmargined_right;

  operator SDL_Rect() const;

  WidgetParameter();

  void  update(int  x, int  y);

  void  print() const;

};


}




#endif




